<?php
/**
 * Main Project class
 *
 * @version    1.0
 * @copyright  reformal.ru, 2008-2010
 * @link       http://reformal.ru/
 */
class ReformalClient extends extXML
{
    /**
     * Number of error
     * @var <int>
     */
    private $errno = 0;

    /**
     * Send Request to Reformal server
     * @param <xml> $data
     * @return <xml || bool>
     */
    private function send($data)
    {
        /**
          * ReformalAnswer($data)
          * Function from libs/main.php
          */
        $answer =  ReformalAnswer($data); 
        if (!$answer)
        {
            $this->errno = 1; // current code of error
            return false;
        }
        else
        {
            $this->xml = $answer['res']; // set local xml buff
            return $answer['res'];
        }
    }#Send


    // ----------------------- Pages ----------------------- //

    /**
     * Show login page
     */
    public function logIn()
    {
        if (isset ($_REQUEST['login']))
        {
            $this->send(
                    $this->getLogin(
                    $_REQUEST['login'],
                    $_REQUEST['password']
                    )
            );
            $code   = (int)$this->readSub('error','code');
            $token  = (string)$this->readSub('session','token');
            if ($code)
            {
                uni_redirect('/?err=login');
            }
            if (!empty ($token))
            {
                $_SESSION['token'] = $token;
                uni_redirect('/');
            }
        }else
        {
            loginForm();
        }
    }#login


    /**
     * Show main page
     */
    public function main()
    {
        $this->send(
                $this->ideasList()
        );

        $code   = (int)$this->readSub('error','code');

        if (!$code)
        {
            // XML2Array Example
            $xml = new SimpleXMLElement($this->xml);
            $ideas = array ();
            foreach ($xml->children() as $key=>$val)
            {
                $info = array ();
                foreach ($val->children() as $k=>$v)
                {
                    $info[$k] = (string)$v;
                }
                $ideas[] = $info;
            }

            echoIdeasList($ideas);
        }else
        {
            $this->logIn();
        }
    }#main


    /**
     * Idea page
     */
    public function idea()
    {
        $this->send(
                $this->ideaInfo($_REQUEST['id'])
        );
        $code   = (int)$this->readSub('error','code');

        if (!$code)
        {
            $xml = new SimpleXMLElement($this->xml);
            $comments = array ();
            foreach ($xml->children() as $key=>$val)
            {
                if ($key=='ideaComments')
                {
                    foreach ($val->children() as $k=>$v)
                    {
                        if ($k == 'comments')
                        {
                            foreach ($v->children() as $k1=>$v1)
                            {
                                $comments[] = (array)$v1;
                            }
                        }
                    }
                }
            }
            $xml = (array)$xml;
            $info = (array)$xml['info'];
            $idea_comms = $comments;

            echoOneIdea($info, &$idea_comms);
        }else
        {
            $this->logIn();
        }
    }#idea


    // ----------------------- Add Methods ----------------------- //
    

    /**
     * Add comment to idea
     */
    public function addComm()
    {
        $idea_id = isset($_REQUEST['idea_id']) ? (int)$_REQUEST['idea_id'] : 0;
        $comment = isset($_REQUEST['comment']) ? (string)$_REQUEST['comment'] : '';

        if ($idea_id && !empty ($comment))
        {
            $this->send(
                    $this->addComment($idea_id,$comment)
            );
        }

        uni_redirect('/?mod=idea&id='.$idea_id);
    }#addComm


    /**
     * Add idea
     */
    public function addIdea()
    {
        $title = isset($_REQUEST['title']) ? (string)$_REQUEST['title'] : '';
        $story = isset($_REQUEST['story']) ? (string)$_REQUEST['story'] : '';

        if (!empty($title) && !empty($story))
        {
            $this->send(
                   $this->newIdea($title,$story)
            );
        }
        
        uni_redirect('/?add=ok');
    }#addIdea
}#End class
?>