<?php
/**
 * Sub Class for Parser
 * 
 * @version    1.0
 * @copyright  reformal.ru, 2008-2010
 * @link       http://reformal.ru/
 */
class extXML
{
    /**
     * Local buffer of text
     * @var <string>
     */
    public  $xml;


    /**
     * Generate XML for add idea
     * @param <string> $title
     * @param <string> $story
     * @return <xml>
     */
    public function newIdea($title, $story)
    {
        return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
            <addIdea>
                <token>".$_SESSION['token']."</token>
                <project_id>".PROJECT_ID."</project_id>
                <api_id>".API_ID."</api_id>
                <title>".$title."</title>
                <story>".$story."</story>
                <subscribe>1</subscribe>
            </addIdea>
            ";
    }#newIdea


    /**
     * Generate XML for add comment method
     * @param <int> $idea_id
     * @param <string> $comment
     * @return <xml>
     */
    public function addComment($idea_id, $comment)
    {
        return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
                <addIdeaComment>
                    <token>".$_SESSION['token']."</token>
                    <project_id>".PROJECT_ID."</project_id>
                    <api_id>".API_ID."</api_id>
                    <idea_id>".(int)$idea_id."</idea_id>
                    <story>".(string)$comment."</story>
                </addIdeaComment>
            ";
    }#addComment


    /**
     * Generate XML for idea info method
     * @param <int> $id
     * @return <xml>
     */
    public function ideaInfo($id)
    {
        return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
            <ideaInfo>
                <token>".$_SESSION['token']."</token>
                <project_id>".PROJECT_ID."</project_id>
                <api_id>".API_ID."</api_id>
                <id>".(int)$id."</id>
                <with_coms>1</with_coms>
            </ideaInfo>
            ";
    }#ideaInfo


    /**
     * Generate XML for ideas list method
     * @return <xml>
     */
    public function ideasList()
    {
        return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
            <suggestionsList>
                <token>".$_SESSION['token']."</token>
                <project_id>".PROJECT_ID."</project_id>
                <api_id>".API_ID."</api_id>
                <mode>all</mode>
            </suggestionsList>
           ";
    }#ideasList


    /**
     * Generate XML for get login method
     * @param <string> $login
     * @param <string> $pass
     * @return <xml>
     */
    public function getLogin($login, $pass)
    {
        return   "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
            <signIn>
                <login>".$login."</login>
                <password>".$pass."</password>
            </signIn>
           ";
    }#getlogin

   
    //--------------------- System Functions ---------------------//
   

    /**
     * Reading Params
     * @param <string> $parant_element
     * @param <string> $element_name
     * @return <string>
     */
    public function readSub($parant_element, $element_name)
    {
        $x = new SimpleXMLElement($this -> xml);
        
        if (isset($x -> $element_name))
        {
            return $x -> $element_name;
        }
        else
        {
            return '';
        }
    }#readSub

    
    /**
     * Convert WINDOWS-1251 to UTF-8
     * @param <WINDOWS-1251 string> $t
     * @return <UTF-8 sting>
     */
    public function win2utf8($t)
    {
        return iconv('cp1251', 'utf-8//IGNORE//TRANSLIT',$t);
    }#win2utf8


    /**
     * Convert UTF-8 to WINDOWS-1251
     * @param <UTF-8 sting> $t
     * @return <WINDOWS-1251 string>
     */
    public function utf82win($t)
    {
	return mb_convert_encoding($t, 'WINDOWS-1251', 'UTF-8');;
    }#utf82win


}#extXML
?>
