<?php
/**
 * Main Method
 *
 * @param <xml> $data
 * @return <array>
 */
function ReformalAnswer($data='')
{
    try
    {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, XML_SUBMIT_URL); // Reformal URL
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-type: text/xml"));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data); // XML Request data
        curl_setopt($ch, CURLOPT_VERBOSE, 1);

        $result = curl_exec($ch);
        $info = curl_getinfo($ch);
        curl_close($ch);

        return array (
                'res' => (string)$result, // Result XML
                'info'=> (array)$info        // Request info
        );
    }
    catch (Exception $e)
    {
        return false;
    }

}/** ReformalAnswer */


function uni_redirect($url) 
{
    echo '<html><head><meta http-equiv="Refresh" content="0; url='.$url.'" /></head></html>';

    exit(0);
}/** uni_redirect */


function templHeader()
{
    echo '
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Reformal API Demo</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<style>
body{
 background: #5B6D84
}
#first_step{
position: absolute; width: auto; top: 50px; right: 20%; left: 20%; z-index: 9999;
}
.f{
border:  1px solid #afe14c;margin: 10px 0;padding: 20px 10px;
}
.r{
margin: 10px 5px;border-color: #D9E4FF;-moz-border-radius-topleft : 5px;-webkit-border-top-left-radius : 5px;-moz-border-radius-topright : 5px;-webkit-border-top-right-radius : 5px;-moz-border-radius-bottomleft : 5px;-webkit-border-bottom-left-radius : 5px;-moz-border-radius-bottomright : 5px;-webkit-border-bottom-right-radius : 5px;
}
#content{background: #fff;}
h1{}
h2{color:#434343;font-size:18px;font-weight:bold;padding:5px 15px}
h3{color:#434343;font-size:14px;font-weight:normal;padding:5px 15px 8px 15px}
label{
font-weight:bold; font-size:12px;
}
.inp{border:1px solid silver; width:100%}
</style>
</head>
<body>

<div id="first_step">
            <div>
                <a href="/"><img src="http://reformal.ru/i/logo.gif"/></a>
            </div>
           ';
}


function templFooter()
{
    echo '
        </div>
        <div style="color:#fff; font-size:12px;" align="right">Демонстрационное приложение</div>
        </body>
</html>
        ';
}

function loginForm()
{
    if (isset($_REQUEST['err']) && $_REQUEST['err']=='login')
    {
        $err = 'Ошибка авторизации';
    }
    echo '
     <div id="content" class="f r" align="center">
         <div class="f r" style="width:300px;" align="center">
             <h2>Вход</h2>
             <div>'.$err.'</div>
             <form name="fm" method="post">
             <table>
             <tr>
                <td><label>Логин:</label></td>
                <td><input type="text" name="login"/></td>
             </tr>
             <tr>
                <td><label>Пароль:</label></td>
                <td><input type="password" name="password"/></td>
             </tr>
             <tr>
                <td colspan=2><input type="submit" value="Вход"/></td>
             </tr>
             </table>
             </form>
         </div>
     </div>
     ';
}

function echoIdeasList($ideas)
{
    echo '
     <div id="content" class="f r">
     <h2>Cписок идей проекта</h2>
         ';

    for ($i=0;$i<count($ideas);$i++)
    {
        echo '<div class="f r">
                ';
        echo '<h2><a style="text-decoration:none;" href="/?mod=idea&id='.$ideas[$i]['id'].'">'.$ideas[$i]['title'].'</a></h2>';
        echo '<div align="right">
                <small><b>Голосов: </b>'.$ideas[$i]['vote_cnt'].';<br/> <b>Комментариев: </b>'.$ideas[$i]['com_cnt'].';<br/> <b>Дата: </b> '.$ideas[$i]['date'].' '.$ideas[$i]['time'].';<br/>
                    <b>URL:</b> '.$ideas[$i]['url'].'
                </small>
              </div>';
        echo '</div>';
    }

    echo'<div class="f r">
        <b>Добавить идею:</b><br><br/>
        <form name="fm" method="post">
        <input type="hidden" name="mod" value="idea_add" />
        <small>Заголовок:</small><br/>
        <input class="inp" type="text" name="title" /><br/>
        <small>Текст:</small><br/>
        <textarea class="inp" name="story"></textarea><br/><br/>
        <input type="submit" value="Добавить"/>
        </form>
        </div>
     </div>
        ';
}


function echoOneIdea($info, $idea_comms)
{
    echo '
     <div id="content" class="f r">
         ';

    echo '<div class="f r">
                <h2>'.$info['title'].' ID = '.$info['id'].'</h2>
                ';
    echo '<div>
                <small><b>Автор:</b> '.$info['author'].'<br/>
                    <b>UID Авторa:</b> '.$info['author_id'].'<br/>
                <b>Голосов: </b>'.$info['count_vote'].';<br/> <b>Комментариев: </b>'.$info['count_comments'].';<br/> <b>Дата: </b> '.$info['date'].' '.$info['time'].'; </small>
              </div>';

    echo '<div><b>Текст идеи:</b> '.$info['descr'].'</div></div>';


    echo '<div class="f r">Комментарии ('.count($idea_comms).'):<br/>';

    
    $cl = $idea_comms;

    for ($i=0;$i<count($cl);$i++)
    {
        $c_info = (array)$cl[$i];
        echo '<div class="f r"><small>
                <b>'.$c_info['author'].'</b> '.$c_info['date'].' '.$c_info['time'].'
              </small>
              <div style="padding-left:15px;">'.$c_info['story'].'</div></div>
            ';
    }
    echo '<br/><b>Добавить комментарий</b>:<br/><br/>
        <form name="fm" method="post">
        <input type="hidden" name="idea_id" value="'.$info['id'].'" />
        <input class="inp" type="hidden" name="mod" value="comment_add" />
        <textarea class="inp" name="comment"></textarea><br/><br/>
        <input type="submit" value="Добавить"/>
        </form>
        ';
    echo '</div></div>';

    echo'
     </div>
        ';
}
?>